
/*
This file has been generated by Polychrony version 4.22
*/
#include "equationSolving_types.h"
#include "equationSolving_externals.h"
#include "equationSolving_body.h"

/*
  ==> parameters and indexes 
*/
/*
  ==> input signals     
*/
static float a, b, c;
/*
  ==> output signals    
*/
static float x2, x1;
static boolean error, stable;
/*
  ==> local signals     
*/
static boolean OK;
static float cc, bb, dd;
static boolean biterate;
static float next_yy, yy, mx;
static boolean next_stable;
static float L179_next_stable_subexpr, s, x21;
static boolean err2, L279_err, L391_bb, L395_extended_OK, L397_d, L403_extended_d, L406_x_subexpr, L412_extended_x_subexpr, L415_L34_err_1, 
               L418_extended_L34_err_1, L421_error, L424_extended_error, L431_extended_, C_err, C_x, C_x1;

EXTERN boolean equationSolving_initialize()
{
    stable = pk_true;
    bb = 0.0e0;
    mx = 0.0e0;
    next_yy = 1.0;
    equationSolving_step_initialize();
    return pk_true;
}

static void equationSolving_Cluster_1()
{
    if (stable)
        {
        if (!OK)
            {
            if (L421_error)
                {
                err2 = c != 0.0;
                }
            }
        if (OK)
            {
            dd = bb * bb - 4.0 * cc;
            L397_d = dd > 0.0;
            L406_x_subexpr = dd == 0.0;
            L415_L34_err_1 = dd < 0.0;
            }
        L418_extended_L34_err_1 = (OK ? L415_L34_err_1 : pk_false);
        C_err = L418_extended_L34_err_1 || L424_extended_error;
        if (C_err)
            {
            if (L415_L34_err_1) L279_err = pk_true; else L279_err = err2; 
            error = L279_err;
            }
        }
    L403_extended_d = (OK ? L397_d : pk_false);
    if (stable)
        {
        if (OK)
            {
            if (L397_d)
                {
                mx = dd;
                }
            }
        }
    L412_extended_x_subexpr = (OK ? L406_x_subexpr : pk_false);
    if (L397_d) biterate = pk_true; else biterate = !stable; 
    if (L397_d) yy = dd / 2.0; else yy = next_yy; 
    if (biterate) next_yy = (yy + mx / yy) / 2.0; else next_yy = yy; 
    L179_next_stable_subexpr = next_yy - yy;
    if (L179_next_stable_subexpr >= 0.0) s = L179_next_stable_subexpr; else s = -L179_next_stable_subexpr; 
    next_stable = s < (0.00001);
    L391_bb = next_stable && biterate;
    C_x = L391_bb || L412_extended_x_subexpr;
    C_x1 = C_x || L431_extended_;
    if (L391_bb)
        {
        x2 = -((bb - yy) / 2.0);
        }
    if (C_x)
        {
        if (L391_bb) x21 = -((bb + yy) / 2.0); else x21 = -bb / 2.0; 
        }
    if (C_x1)
        {
        if (C_x) x1 = x21; else x1 = -(c / b); 
        }
}

static void equationSolving_Cluster_2()
{
    if (stable)
        {
        OK = a != 0.0;
        }
    L395_extended_OK = (stable ? OK : pk_false);
}

static void equationSolving_Cluster_3()
{
    if (OK)
        {
        cc = c / a;
        }
}

static void equationSolving_Cluster_4()
{
    if (stable)
        {
        if (OK)
            {
            bb = b / a;
            }
        if (!OK)
            {
            L421_error = b == 0.0;
            }
        L424_extended_error = (!OK ? L421_error : pk_false);
        }
    L431_extended_ = (!OK ? !L421_error : pk_false);
}

static void equationSolving_STATES()
{
    stable = next_stable;
    L415_L34_err_1 = pk_false;
    equationSolving_step_initialize();
}

static void equationSolving_step_initialize()
{
    OK = pk_false;
    L397_d = pk_false;
    L406_x_subexpr = pk_false;
    L421_error = pk_false;
}

EXTERN boolean equationSolving_step()
{
    w_equationSolving_stable(stable);
    if (stable)
        {
        if (!r_equationSolving_a(&a)) return pk_false;
        if (!r_equationSolving_b(&b)) return pk_false;
        if (!r_equationSolving_c(&c)) return pk_false;
        }
    equationSolving_Cluster_2();
    equationSolving_Cluster_4();
    if (stable)
        {
        equationSolving_Cluster_3();
        }
    equationSolving_Cluster_1();
    if (stable)
        {
        if (C_err)
            {
            w_equationSolving_error(error);
            }
        }
    if (L391_bb)
        {
        w_equationSolving_x2(x2);
        }
    if (C_x1)
        {
        w_equationSolving_x1(x1);
        }
    equationSolving_STATES();
    return pk_true;
}

