process equationSolving =
     ( ? real a; 
         real b; 
         real c;
       ! real x2; 
         real x1; 
         boolean error;
     )
   (| (| (| SecondDegree_ABSTRACT([:a/=0.0], a, b, c) |)/ stable
                                             / C_CLK_339
                                             / C_x
                                             / L277_PREDICATE
                                             / L283_PREDICATE
       | FirstDegree(a=0.0, b, c)
       | (| a2 := x
          | err1 := err
          | a1 := x21
          | (| u := a1 default a2
             | error := [:err1] default err2
             |)
          | x1 := u
          |) where real u, a1, a2; 
                   boolean err1; end
       | a ^= b ^= c
       |)/ err2, x, err, x21 |)
   where 
   constant real cst_epsilon = 0.0001; 
   boolean err2, err, C_x, C_bb, C_err, stable, C_OK, OK, C_y, C_error, C_cc1; 
   process FirstDegree =
        ( ? boolean Compute; 
            real b; 
            real c;
          ! real x; 
            boolean err2;
        )
      (| (| (| (| c := cc_2
                | b := bb_1
                | (| bb := b when (b/=0.0)
                   | cc := c when (b/=0.0)
                   | x := -(cc/bb)
                   |)
                |)/ cc, bb |) where real b, c; end
          | (| c := cc_2
             | b := bb_1
             | error := (c/=0.0) when (b=0.0)
             | err2 := error
             |) where boolean error; 
                      real b, c; end
          | (| (| bb := b when Compute
                | cc := c when Compute
                |)
             | bb_1 := bb
             | cc_2 := cc
             |) where real bb, cc; end
          |)/ cc_2, bb_1 |)
      where 
      real bb, cc, bb_1, cc_2;
      end
   ; 
   process SecondDegree_ABS =
        ( ? real a, b, c;
          ! boolean err; 
            real x21, x2; 
            boolean stable, C_bb, OK, C_err, C_x21;
        )
        spec (| (| {a, b, c} --> {err, x21, x2}
                 | {{a, b, c} --> C_bb} when C_bb
                 | {a --> OK} when OK
                 | {{a, b, c} --> C_err} when C_err
                 | {{a, b, c} --> C_x21} when C_x21
                 |)
              | (| stable ^= C_bb ^= C_x21
                 | [:stable] ^= a ^= b ^= c ^= OK
                 | [:C_bb] ^= x2
                 | [:OK] ^= C_err
                 | [:C_err] ^= err
                 | [:C_x21] ^= x21
                 |)
              |)
      pragmas 
         BlackBox "SecondDegree"
      end pragmas
      external "C"
   ; 
   process SecondDegree_ABSTRACT =
        ( ? boolean OK; 
            real a, b, c;
          ! boolean err; 
            real x21, x2; 
            boolean stable, L277_PREDICATE, L283_PREDICATE, C_x, C_CLK_339;
        )
        spec (| (| c --> err
                 | c --> x21
                 | c --> x2
                 | b --> err
                 | b --> x21
                 | b --> x2
                 | a --> OK
                 | a --> err
                 | a --> x21
                 | a --> x2
                 | b --> c
                 | a --> b
                 |)
              | (| stable ^= L283_PREDICATE ^= C_x ^= C_CLK_339
                 | [:C_x] ^= x21
                 | [:stable] ^= a ^= b ^= c
                 | [:L283_PREDICATE] ^= x2
                 | [/:a=0.0] ^= OK ^= L277_PREDICATE
                 | [:L277_PREDICATE] ^= err
                 |)
              | assert ( err )
              |)
      pragmas 
         BlackBox "SecondDegree"
      end pragmas
      external "C"
   ; 
   C_CLK_339, L277_PREDICATE, L283_PREDICATE; 
   real x21, x;
   end
; 
