
module ARCHI_COST =

   constant integer nbTypes = 11;
   type HomoType = integer;
   constant HomoType  NilHomoTypeValue =0 ;
   constant HomoType  _undef = -1;
   constant HomoType  CST_COST_TEST = 2;
   constant HomoType  CST_COST_AND = 2;
   constant HomoType  CST_COST_OR = 2;

   constant [nbTypes, nbTypes]HomoType TAB_COST_RELA=
      [{to (nbTypes-1), to (nbTypes-1)} : _undef, % init. %
      %_short (2) , _integer(3), _long(4), _real(5), _dpreal(6) % 
      [2,2]:3 % short, short % , 
      [2,3]:3 % short, int % ,
      [2,4]:3 % short, long % ,
      [3,2]:3 % int, short % ,
      [3,3]:3 % int, int % ,
      [3,4]:3 % int, long % ,
      [4,2]:3 % long, short % ,
      [4,3]:3 % long, integer % ,
      [4,4]:3 % long, long % ,
      [5,5]:5 % real, real % ,
      [5,6]:5 % real, dpreal % ,
      [6,5]:5 % dpreal, real % ,
      [6,6]:5 % dpreal, dpreal %
      ];

     constant [nbTypes]HomoType TAB_ASSIGN=[{ to (nbTypes-1)}: 2];
constant [nbTypes]HomoType TAB_COST_READ=
          [ 1 %_event% , 1 %_logical% , 
            2 %_short% , 2 % _integer %, 2  %_long %, 
	    4 %_real % , 4 %_dpreal %,
            _undef, _undef, _undef ,_undef
          ];


   constant [nbTypes]HomoType TAB_COST_WRITE=
          [ 1 %_event% , 1 %_logical% , 
            2 %_short% , 2 % _integer %, 2  %_long %, 
	    4 %_real % , 4 %_dpreal %,
            _undef, _undef, _undef ,_undef
          ];


     constant [nbTypes]HomoType TAB_UMINUS=
          [_undef,_undef, 1, 2, 3, 4, 5, _undef, _undef, _undef ,_undef];
     constant [nbTypes, nbTypes]HomoType TAB_PLUS=
     [{to (nbTypes-1), to (nbTypes-1)} : _undef,
      %_short (2) , _integer(3), _long(4), _real(5), _dpreal(6) % 
      [2,2]:3 % short, short % , 
      [2,3]:3 % short, int % ,
      [2,4]:3 % short, long % ,
      [3,2]:3 % int, short % ,
      [3,3]:3 % int, int % ,
      [3,4]:3 % int, long % ,
      [4,2]:3 % long, short % ,
      [4,3]:3 % long, integer % ,
      [4,4]:3 % long, long % ,
      [5,5]:5 % real, real % ,
      [5,6]:5 % real, dpreal % ,
      [6,5]:5 % dpreal, real % ,
      [6,6]:5 % dpreal, dpreal %
      ];

     constant [nbTypes, nbTypes]HomoType TAB_MINUS=
      [{to (nbTypes-1), to (nbTypes-1)} : _undef, % init. %
      %_short (2) , _integer(3), _long(4), _real(5), _dpreal(6) % 
      [2,2]:3 % short, short % , 
      [2,3]:3 % short, int % ,
      [2,4]:3 % short, long % ,
      [3,2]:3 % int, short % ,
      [3,3]:3 % int, int % ,
      [3,4]:3 % int, long % ,
      [4,2]:3 % long, short % ,
      [4,3]:3 % long, integer % ,
      [4,4]:3 % long, long % ,
      [5,5]:5 % real, real % ,
      [5,6]:5 % real, dpreal % ,
      [6,5]:5 % dpreal, real % ,
      [6,6]:5 % dpreal, dpreal %
      ];

% --- locals %
   function GET_COST_RELA =
        ( ? __TC__ VTYPE1, VTYPE2;
          ! HomoType vc;
        )
    (| vc := TAB_COST_RELA[integer(VTYPE1),integer(VTYPE2) ]
     |)
;
   function GET_COST_ASSIGN = ( ? __TC__ VTYPE; ! HomoType vc;)
   (| vc := TAB_ASSIGN[integer(VTYPE)] |) 
% -- end locals %
;
   function GET_COST_READ=
        ( ? __TC__ VTYPE;
          ! HomoType vc;
        )
	(| vc := TAB_COST_READ[integer(VTYPE)] |)
;

   function GET_COST_WRITE=
        ( ? __TC__ VTYPE;
          ! HomoType vc;
        )
	(| vc := TAB_COST_WRITE[integer(VTYPE)] |)
;

   function GET_COST_CONST =
        ( ? __TC__ VTYPE;
          ! HomoType vc;
        )
    (| vc := 0 |)
   %GET_COST_CONST%; 
   function GET_COST_NOT =
        ( ! HomoType vc;
        )
       (| vc := 1 |)
   %GET_COST_NOT%; 

   function GET_COST_MODULO =
        ( ! HomoType vc;
        )
       (| vc := 1 |)
   %GET_COST_MODULO%; 

   function GET_COST_AND =
        ( ! HomoType vc;
        )
      (| vc := 2 |)
   %GET_COST_AND%; 
   function GET_COST_OR =
        ( ! HomoType vc;
        )
         (| vc := 2 |)
   %GET_COST_OR%; 
   function GET_COST_EOR =
        ( ! HomoType vc;
        )
         (| vc := 2 |)
   %GET_COST_EOR%; 
   function GET_COST_UMINUS =  % _short, _integer, _long, _real, _dpreal %
        ( ? __TC__ VTYPE;
          ! HomoType vc;
        )
    (| vc := TAB_UMINUS[integer(VTYPE)] |)


   %GET_COST_UMINUS%; 
   function GET_COST_PLUS ={ __TC__ VTYPE1, VTYPE2; }
   (? ! HomoType vc; )
    (| vc := TAB_PLUS[integer(VTYPE1),integer(VTYPE2) ]
     |)

   ; 
   function GET_COST_MINUS =
        ( ? __TC__ VTYPE1, VTYPE2;
          ! HomoType vc;
        )
    (| vc := TAB_MINUS[integer(VTYPE1),integer(VTYPE2) ]
     |)
    ;

   function GET_COST_POW = 
        ( ? __TC__ VTYPE1; 
          ! HomoType vc;
        )
    (| vc := 10 %  I don't know ??? %
     |)
  ;

   function GET_COST_MULT =
        ( ? __TC__ VTYPE1, VTYPE2;
          ! HomoType vc;
        )
        (| vc := TAB_PLUS[integer(VTYPE1),integer(VTYPE2) ] |)
   %GET_COST_MULT%; 

   function GET_COST_DIVI =
        ( ? __TC__ VTYPE1, VTYPE2;
          ! HomoType vc;
        )
        (| vc := TAB_PLUS[integer(VTYPE1),integer(VTYPE2) ] |)
   %GET_COST_DIVI%; 
   function GET_COST_EQ =
        ( ? __TC__ VTYPE1, VTYPE2;
          ! HomoType vc;
        )
    (| vc := GET_COST_RELA(VTYPE1,VTYPE2) |)
   ;

   function GET_COST_NEQ =
        ( ? __TC__ VTYPE1, VTYPE2;
          ! HomoType vc;
        )
       (| vc := GET_COST_RELA(VTYPE1,VTYPE2) |)
;

   function GET_COST_LEQ =
        ( ? __TC__ VTYPE1, VTYPE2;
          ! HomoType vc;
        )
       (| vc := GET_COST_RELA(VTYPE1,VTYPE2) |)
;
   function GET_COST_GEQ =
        ( ? __TC__ VTYPE1, VTYPE2;
          ! HomoType vc;
        )
       (| vc := GET_COST_RELA(VTYPE1,VTYPE2) |)
;   
   function GET_COST_LT =
        ( ? __TC__ VTYPE1, VTYPE2;
          ! HomoType vc;
        )
       (| vc := GET_COST_RELA(VTYPE1,VTYPE2)|) 
;

   function GET_COST_GT = ( ? __TC__ VTYPE1, VTYPE2; ! HomoType vc; )
       (| vc := GET_COST_RELA(VTYPE1,VTYPE2) |) 
;
   function GET_COST_WHEN1 =
        ( ! HomoType vc;
        )
     (| vc := CST_COST_TEST |)
    
   %GET_COST_WHEN1%; 
   function GET_COST_WHEN =
        ( ? __TC__ VTYPE;
          ! HomoType vc;
        )
    (| vc := CST_COST_TEST + GET_COST_ASSIGN(VTYPE) |)
   %GET_COST_WHEN%; 
   function GET_COST_DEFAULT =
        ( ? __TC__ VTYPE;
          ! HomoType vc;
        )
        (| vc := CST_COST_TEST |)
   %GET_COST_DEFAULT%; 
   function GET_COST_EVENT =
        ( ! HomoType vc;
        )
   
   %GET_COST_EVENT%; 
   function GET_COST_LEFT_TT =
        ( ! HomoType vc;
        )
    (| vc := CST_COST_TEST + GET_COST_ASSIGN(__TC__#_logical) |)
   ;	
   function GET_COST_CELL =
        ( ? __TC__ VTYPE;
          ! HomoType vc;
        )
    (| vc := GET_COST_ASSIGN(VTYPE) |)
  ; 
   function GET_COST_DELAY_WR =
        ( ? __TC__ VTYPE;
          ! HomoType vc;
        )
        (| vc := GET_COST_ASSIGN(VTYPE) |)
   %GET_COST_DELAY_WR%; 
   function GET_COST_DELAY_RD =
        ( ? __TC__ VTYPE;
          ! HomoType vc;
        )
           (| vc := NilHomoTypeValue |)
   %GET_COST_DELAY_RD%; 
   function GET_COST_COMM =
        ( ? __TC__ VTYPE;
          ! HomoType vc;
        )
   
   %GET_COST_COMM%; 

   end;
