module Morphism_TABLE = 

%  To be completed. %
%  ---------------  %

%
  PREDEFINED IDENTIFIERS.  
      The following names are known by the Signal compiler 
      They are defined in $GraphVM_Morphism/export/morphismPredefinedNames.h file in Polychrony distribution.
% 

operator _TYPE_         = (? ! ) pragmas Morphism "HomoType" end pragmas;
operator _IDENT_        = (? ! ) pragmas Morphism "d_&n" end pragmas;
operator _CONSTANT_     = (? ! ) pragmas Morphism "CostConst{&t}()" end pragmas;
operator _EXTERNALCALL_ = (? ! ) pragmas Morphism "(&lexp&o, &done) := Cost&n{}(&lexp&i, &hck&o, &wait)"  end pragmas;
operator _LABEL_        = (? ! ) pragmas Morphism "(&h&o, &done) := CostSubGraph{}(&h&i1, &h&i2, &hck&o, &wait)" end pragmas;

operator _ELEMACCESS_      = (? ! ) pragmas Morphism "(&h&o, &done) := CostElemAccess{&t&i1}(&h&i1,&hck&o, &wait )"  end pragmas; % x[] %
operator _ENUMVALUEACCESS_ = (? ! ) pragmas Morphism "CostConst{&t}()"  end pragmas; % T#v %
operator _FIELDACCESS_     = (? ! ) pragmas Morphism "(&h&o, &done) := CostFieldAccess(&h&i1, &hck&o, &wait)" end pragmas;  % x.y %

%operator _DEPENDENCE_ = (? ! ) pragmas Morphism "DEPENDENCE{}()" end pragmas;% % x --> y when c %
operator _DEPENDENCE_ = (? ! ) pragmas Morphism "-->{}()" end pragmas;

operator _RENAME_ = (? x; ! z;) pragmas Morphism "(&h&o, &done) := CostRenaming{&t&i1}(&h&i1, &hck&o, &wait)" end pragmas; % x:= y %
operator _READ_ = (?z;)        pragmas Morphism "(&h&o, &done) := CostInput{&t&i1}(&h&i1, &hck&i1, &wait)" end pragmas;   % ? x %
operator _WRITE_ = (? x; ! z;)  pragmas Morphism "(&h&o, &done) := CostOutput{&t&i1}(&h&i1, &hck&i1, &wait)" end pragmas;  % ! x %
operator _LELEVEC_ = (? ! )    pragmas Morphism "(&h&o, &done) := CostLELEVEC_&cpt{}(&lexp&i, &wait)"   end pragmas; % oplelevec % 
operator _ENSVEC_ = (? ! )     pragmas Morphism "(&h&o, &done) := CostENSVEC_&cpt{}(&lexp&i, &wait)"   end pragmas; % opensvec % 
operator _TUPLE_ASS_ = (? ! )  pragmas Morphism "(&h&o, &done) := CostTUPLE_&cpt{}(&lexp&i, &wait)"   end pragmas; % opleflot, x := (e1,e2,...en) %

% Conversion %
operator Conversion = (? x; !y; ) pragmas Morphism "(&h&o, &done) := CostConv&n{}(&h&i1, &hck&o, &wait)" end pragmas;

operator true  = (? ! ) pragmas Morphism "CostConst{&t}()" end pragmas;
operator false = (? ! ) pragmas Morphism "CostConst{&t}()" end pragmas;

%  Relational operators %
%  -------------------- %

operator /= = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done) :=CostNEQ{&t&i1,&t&i2}  (&h&i1, &h&i2, &hck&o, &wait)" end pragmas;
operator / = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done)  :=CostDivi{&t&i1,&t&i2} (&h&i1, &h&i2, &hck&o, &wait)" end pragmas;
operator = = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done)  :=CostEQ{&t&i1,&t&i2}   (&h&i1, &h&i2, &hck&o, &wait)" end pragmas;
operator <= = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done) :=CostLEQ{&t&i1,&t&i2}  (&h&i1, &h&i2, &hck&o, &wait)" end pragmas;
operator <<= = (? x,y; ! z; )pragmas Morphism "(&h&o, &done) :=CostLLEQ{&t&i1,&t&i2} (&h&i1, &h&i2, &hck&o, &wait)" end pragmas;
operator < = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done)  :=CostLT{&t&i1,&t&i2}   (&h&i1, &h&i2, &hck&o, &wait)" end pragmas;
operator >= = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done) :=CostGEQ{&t&i1,&t&i2}  (&h&i1, &h&i2, &hck&o, &wait)" end pragmas;
operator > = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done)  :=CostGT{&t&i1,&t&i2}   (&h&i1, &h&i2, &hck&o, &wait)" end pragmas;
operator == = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done) :=CostEQEQ{&t&i1,&t&i2} (&h&i1, &h&i2, &hck&o, &wait)" end pragmas;

%  logical operators %
%  ----------------- %
operator not = (? x; ! z; ) pragmas Morphism "(&h&o, &done) :=CostNot{}(&h&i1, &hck&o, &wait)" end pragmas;
operator and = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done) :=CostAnd{}(&h&i1, &h&i2, &hck&o, &wait)" end pragmas;
operator or = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done) :=CostOr{}(&h&i1, &h&i2, &hck&o, &wait)" end pragmas;
operator xor = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done) :=CostEor{}(&h&i1, &h&i2, &hck&o, &wait)" end pragmas;


% Arithm operators %
% ---------------- %
operator modulo = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done) :=CostModulo{}(&h&i1, &h&i2, &hck&o, &wait)" end pragmas;
operator - = (? x; ! z; ) pragmas Morphism  "(&h&o, &done) :=CostUMinus{&t&i1}(&h&i1, &hck&o, &wait)" end pragmas;
operator - = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done) :=CostMinus{&t&i1,&t&i2}(&h&i1, &h&i2, &hck&o, &wait)" end pragmas;
operator * = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done) :=CostMult{&t&i1,&t&i2}(&h&i1, &h&i2, &hck&o, &wait)" end pragmas;
operator + = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done) :=CostPlus{&t&i1,&t&i2}( &h&i1, &h&i2, &hck&o, &wait)" end pragmas;
operator ** = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done) :=CostPow{&t&i1,&t&i2}(&h&i1, &h&i2, &hck&o, &wait)" end pragmas;

% SIGNAL specific operators %
% ------------------------- %
operator leftTT = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done) :=CostLeftTT{}(&h&i1, &h&i2, &hck&o, &wait)" end pragmas;
operator when = (? x; ! z; ) pragmas Morphism "(&h&o, &done) :=CostWhen1{}(&h&i1, &hck&i1, &wait)" end pragmas;
operator when = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done) :=CostWhen{&t}(&h&i1, &h&i2, &wait )" end pragmas;
operator default = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done) :=CostDefault{&t}(&h&i1, &h&i2, &hck&o, &wait)" end pragmas;
operator window = (? ! ) pragmas Morphism "(&h&o, &done) :=CostWindow{&t}(&h&i1, &hck&o, &wait)" end pragmas;
operator cell = (? ! ) pragmas Morphism "(&h&o, &done) := CostCell{&t}(&h&i1, &h&i2, &hck&o, &wait)" end pragmas;
operator $ = (? ! ) pragmas Morphism "(&h&o, &done) := CostDelay{&t}(&h&i1, &hck&o, &wait))" end pragmas;
operator ^* = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done) :=CostClkMult{&t}(&h&i1, &h&i2, &hck&o, &wait)" end pragmas;
operator ^+ = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done) :=CostClkPlus{&t}(&h&i1, &h&i2, &hck&o, &wait)" end pragmas;
operator ^- = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done) :=CostClkMinus{&t}(&h&i1, &h&i2, &hck&o, &wait)" end pragmas;
operator count = (? x,y; ! z; ) pragmas Morphism "(&h&o, &done) :=CostCount{&t}(&h&i1, &h&i2, &hck&o, &wait)" end pragmas;


% list Operators % 
%----------------- % 
   % operator  oplident = (? ! ) pragmas Morphism "CostLIST{}(&h&i1, &h&i2)"   end pragmas;
     operator  oplesign = (? ! ) pragmas Morphism "CostLIST{&t}(&h&i1, &h&i2)"   end pragmas;
     operator  opchai = (? ! ) pragmas Morphism "CostLSTRING{&t}(&h&i1, &h&i2)" end pragmas;
   %

% For constants (operators: opcstcar, opcstcha, opcstdp, opcstent, opcstreel, opdcomplex, opdpreal, opevent, opfalse, ophnull) see the _CONSTANT_ operator %
% For externalCall See _EXTERNALCALL_ operator. %
end;
