module AUTOMATON_INTRINSICS =

process Automaton_Initial_State = (? S1; !); 
     % Fixing the initial state %

process Automaton_Transition = (? S1, S2; event trigger; integer prio !);     
     %  Defining a transition : S1 -[trigger]-> S2. The clock of the transition is [in(S1)] ^* trigger, with prio as associated priority.
        The prio argument is optionnal (0 by default). %

process Automaton_IsIn= (? S; ! boolean b) ;                     
     % Testing the current state of an automaton (ie in(S) ). Not clocked expression %

process Automaton_SetClock = (? event clockExpr); 
     %  Fixing the clock of an automaton by clockExpr expression. 
        By default, it is the upper bound of the clocks of the inputs of the automaton. %
                                  
process Automaton_Clock = (? ! event vAutomatonclk);             
     %  return the clock of the automaton %
                            
process Automaton_SetCurrentStateId = (? id; !); 
     %  specifies the state variable of an automaton%

% --- Regular expressions --- NOT YET IMPLEMENTED %
   process Regular_Star = (? E; ! NE);
   process Regular_Conc = (? E1, E2; ! NE);
   process Regular_Sum  = (?E1, E2; ! NE);
   process Regular_Pow  = (?E; integer n; ! NE);
end;

